package org.springblade.person.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.person.entity.Prisoner;
import org.springblade.person.vo.PrisonerVO;
import org.springblade.person.wrapper.PrisonerWrapper;
import org.springblade.person.service.IPrisonerService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-28
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/prisoner")

public class PrisonerClient implements IPrisonerClient {

    private final IPrisonerService prisonerService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public PrisonerVO detail(@SpringQueryMap Prisoner prisoner) {
        Prisoner detail = prisonerService.getOne(Condition.getQueryWrapper(prisoner));
        return PrisonerWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<PrisonerVO> list(Prisoner prisoner) {
        return PrisonerWrapper.build().listVO(prisonerService.list(Condition.getQueryWrapper(prisoner)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody Prisoner prisoner) {
        return prisonerService.save(prisoner);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Prisoner prisoner) {
        return prisonerService.updateById(prisoner);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Prisoner prisoner) {
        return prisonerService.saveOrUpdate(prisoner);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return prisonerService.deleteLogic(Func.toLongList(ids));
        }


}
